---
title: <easing-function>
slug: Web/CSS/easing-function
tags:
  - API
  - CSS
  - CSS Animations
  - CSS Data Type
  - CSS Transitions
  - Data Type
  - Layout
  - Reference
  - easing-function
---
<div>{{CSSRef}}</div>

<p>The <strong><code>&lt;easing-function&gt;</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Types">data type</a> denotes a mathematical function that describes the rate at which a numerical value changes.</p>

<p>This transition between two values may be applied in different situations. It may be used to describe how fast values change during animations. This lets you vary the animation's speed over the course of its duration. It may also be used to interpolate between two colors in a color gradient.</p>

<p>The easing functions in the cubic-bezier subset of easing functions are often called "smooth" easing functions, because they can be used to smooth down the start and end of the interpolation. They correlate an input ratio to an output ratio, both expressed as {{cssxref("&lt;number&gt;")}}s. For these values, <code>0.0</code> represents the initial state, and <code>1.0</code> represents the final state.</p>

<p><img src="/files/3434/TF_with_output_gt_than_1.png" style="float: left;"><img src="/files/3435/TF_with_output_gt_than_1_clipped.png" style="float: left; margin-right: 5px;"></p>

<p class="cleared">Depending on the specific function used, the calculated output can sometimes grow to be greater than <code>1.0</code> or smaller than <code>0.0</code> during the course of an animation. This causes the value to go farther than the final state, and then return. In animations, for some properties, such as {{cssxref("left")}} or {{cssxref("right")}}, this creates a kind of "bouncing" effect.</p>

<p>However, certain properties will restrict the output if it goes outside an allowable range. For example, a color component greater than <code>255</code> or smaller than <code>0</code> will be clipped to the closest allowed value (<code>255</code> and <code>0</code>, respectively). Some <code>cubic-bezier()</code> curves exhibit this property.</p>

<h2 class="cleared" id="Syntax">Syntax</h2>

<p>There are three types of <a href="/en-US/docs/Web/CSS/easing-function#Easing_functions">easing function</a>: linear, <a href="https://en.wikipedia.org/wiki/B%C3%A9zier_curve#Cubic_B.C3.A9zier_curves">cubic Bézier curves</a>, and staircase functions. The value of an <code>&lt;easing-function&gt;</code> type describes the easing function using one of those three types.</p>

<h3 class="cleared" id="Easing_functions">Easing functions</h3>

<p>CSS supports three kinds of easing functions: linear, the subset of the cubic Bézier curves that are functions, and staircase functions. The most useful of these functions are given a keyword that allows them to be easily referenced.</p>

<h4 id="The_linear_class_of_easing_functions">The linear class of easing functions</h4>

<h5 id="linear">linear</h5>

<p style="float: left;"><img src="/files/3425/cubic-bezier,linear.png" style="height: 325px; width: 244px;"></p>

<p>The interpolation is done at a constant rate from beginning to end. This keyword represents the easing function <code>cubic-bezier(0.0, 0.0, 1.0, 1.0)</code>.</p>

<h4 class="cleared" id="cubic-bezier" name="cubic-bezier()">The cubic-bezier() class of easing functions</h4>

<p style="float: left;"><img src="/files/3433/cubic-bezier,%20example.png"></p>

<p>The <code>cubic-bezier()</code> functional notation defines a <a href="https://en.wikipedia.org/wiki/B%C3%A9zier_curve#Cubic_B.C3.A9zier_curves">cubic Bézier curve</a>. As these curves are continuous, they are often used to smooth down the start and end of the interpolation and are therefore sometimes called <em>easing functions</em>.</p>

<p>A cubic Bézier curve is defined by four points P<sub>0</sub>, P<sub>1</sub>, P<sub>2</sub>, and P<sub>3</sub>. P<sub>0</sub> and P<sub>3</sub> are the start and the end of the curve and, in CSS these points are fixed as the coordinates are ratios (the abscissa the ratio of time, the ordinate the ratio of the output range). P<sub>0</sub> is <code>(0, 0)</code> and represents the initial time or position and the initial state, P<sub>3</sub> is <code>(1, 1)</code> and represents the final time or position and the final state.</p>

<p>Not all cubic Bézier curves are suitable as easing functions as not all are <a href="https://en.wikipedia.org/wiki/Function_%28mathematics%29">mathematical functions</a>; i.e., curves that for a given abscissa have zero or one value. With P<sub>0</sub> and P<sub>3</sub> fixed as defined by CSS, a cubic Bézier curve is a function, and is therefore valid, if and only if the abscissas of P<sub>1</sub> and P<sub>2</sub> are both in the <code>[0, 1]</code> range.</p>

<p>Cubic Bézier curves with the P<sub>1</sub> or P<sub>2</sub> ordinate outside the <code>[0, 1]</code> range may generate <em>bouncing</em> effects.</p>

<p>When you specify an invalid <code>cubic-bezier</code> curve, CSS ignores the whole property.</p>

<h5 id="Syntax_2">Syntax</h5>

<pre class="syntaxbox notranslate">cubic-bezier(<var>x<sub>1</sub></var>, <var>y<sub>1</sub></var>, <var>x<sub>2</sub></var>, <var>y<sub>2</sub></var>)
</pre>

<p>where:</p>

<dl>
 <dt><strong><var>x<sub>1</sub></var>, <var>y<sub>1</sub></var>, <var>x<sub>2</sub></var>, <var>y<sub>2</sub></var></strong></dt>
 <dd>Are {{cssxref("&lt;number&gt;")}} values representing the abscissas, and ordinates of the P<sub>1</sub> and P<sub>2</sub> points defining the cubic Bézier curve. x<sub>1</sub> and x<sub>2</sub> must be in the range [0, 1] or the value is invalid.</dd>
</dl>

<h4 id="Keywords_for_common_cubic-bezier_easing_functions">Keywords for common cubic-bezier easing functions</h4>

<h5 id="ease">ease</h5>

<p><img src="/files/3429/cubic-bezier,ease.png" style="height: 332px; width: 244px;"></p>

<p>The interpolation starts slowly, accelerates sharply, and then slows gradually towards the end. This keyword represents the easing function <code>cubic-bezier(0.25, 0.1, 0.25, 1.0)</code>. It is similar to <a href="#ease-in-out"><code>ease-in-out</code></a>, though it accelerates more sharply at the beginning.</p>

<h5 id="ease-in">ease-in</h5>

<p><img src="/files/3426/cubic-bezier,ease-in.png" style="height: 325px; width: 244px;"></p>

<p>The interpolation starts slowly, and then progressively speeds up until the end, at which point it stops abruptly. This keyword represents the easing function <code>cubic-bezier(0.42, 0.0, 1.0, 1.0)</code>.</p>

<h5 id="ease-in-out"><code>ease-in-out</code></h5>

<p><img src="/files/3428/cubic-bezier,ease-in-out.png" style="height: 332px; width: 244px;"></p>

<p>The interpolation starts slowly, speeds up, and then slows down towards the end. This keyword represents the easing function <code>cubic-bezier(0.42, 0.0, 0.58, 1.0)</code>. At the beginning, it behaves like the <a href="#ease-in"><code>ease-in</code></a> function; at the end, it is like the <a href="#ease-out"><code>ease-out</code></a> function.</p>

<h5 id="ease-out">ease-out</h5>

<p><img src="/files/3427/cubic-bezer,ease-out.png" style="height: 325px;"></p>

<p>The interpolation starts abruptly, and then progressively slows down towards the end. This keyword represents the easing function <code>cubic-bezier(0.0, 0.0, 0.58, 1.0)</code>.</p>

<h4 id="steps">The steps() class of easing functions</h4>

<p>The <code>steps()</code> functional notation defines a <a href="https://en.wikipedia.org/wiki/Step_function">step function</a> dividing the domain of output values in equidistant steps.This subclass of step functions are sometimes also called <em>staircase functions</em>.</p>

<h5 id="Syntax_3">Syntax</h5>

<pre class="syntaxbox notranslate">steps(<var>number_of_steps</var>, <var>direction</var>)
</pre>

<p>where:</p>

<dl>
 <dt><var>number_of_steps</var></dt>
 <dd>Is a strictly positive {{cssxref("&lt;integer&gt;")}}, representing the amount of equidistant treads composing the stepping function.</dd>
 <dt><var>direction</var></dt>
 <dd>Is a keyword indicating if it the function is <a href="https://en.wikipedia.org/wiki/Left-continuous#Directional_and_semi-continuity">left- or right-continuous</a>:</dd>
 <dd>
 <ul>
  <li><code>jump-start</code> denotes a left-continuous function, so that the first step or jump happens when the interpolation begins;</li>
  <li><code>jump-end</code> denotes a right-continuous function, so that the last step or jump happens when the interpolation ends;</li>
  <li><code>jump-both</code> denotes a right and left continuous function, includes pauses at both the 0% and 100% marks, effectively adding a step during the interpolation iteration;</li>
  <li><code>jump-none</code> There is no jump on either end. Instead, holding at both the 0% mark and the 100% mark, each for 1/n of the duration</li>
  <li><code>start</code> is the equivalent of <code>jump-start</code></li>
  <li><code>end</code> is the equivalent of <code>jump-end</code></li>
 </ul>
 </dd>
 <dd><code>end</code> is the default.</dd>
</dl>

<h5 id="steps_n_&lt;direction&gt;">steps( n, &lt;direction&gt; )</h5>

<ul style="list-style-type: none; display: flex;">
 <li>
  <p><code>steps(2, jump-start)</code><br>
   <code>steps(2, start)</code></p>
  <img src="/files/3436/steps(2,start).png" style="float: left; height: 327px; vertical-align: top;"></li>
 <li>
  <p><code>steps(4, jump-end)<br>
   steps(4, end)</code></p>
  <img alt="four steps, with a jump from the fourth step to the final value at the 100% mark" src="/files/3437/steps(4,end).png"></li>
 <li>
  <p><code>steps(5, jump-none)</code></p>
  <img alt="five steps, with no jumps, so 20% of the time is at the beginning state or 0% mark and the last 20% is at the final state, or 100% mark" src="/files/16419/step5none.png"></li>
 <li>
  <p><code>steps(3, jump-both)</code></p>
  <img src="https://mdn.mozillademos.org/files/16420/step3both.png"></li>
</ul>

<h5 class="cleared" id="step-start">step-start</h5>

<p><img src="/files/3423/steps(1,start).png" style="float: left; height: 327px; vertical-align: top;"> The interpolation jumps immediately to its final state, where it stays until the end. This keyword represents the easing function <code>steps(1, jump-start)</code> or <code>steps(1, start)</code>.</p>

<h5 class="cleared" id="step-end">step-end</h5>

<p><img src="/files/3424/steps(1,end).png" style="float: left; height: 327px; vertical-align: top;"> The interpolation stays in its initial state until the end, at which point it jumps directly to its final state. This keyword represents the easing function <code>steps(1, jump-end)</code> or <code>steps(1, end)</code>.</p>

<h2 class="cleared" id="Examples">Examples</h2>

<h3 id="Easing_function_comparison">Easing function comparison</h3>

<p>This example creates an animation that can be started and stopped again using the provided button, and a select menu that can be used to switch its easing function between the available keywords, plus a couple of <code>cubic-bezier()</code> and <code>steps()</code> options. The idea is to provide an easy comparison between different easing functions.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;div&gt;
  &lt;div&gt;&lt;/div&gt;
&lt;/div&gt;
&lt;ul&gt;
  &lt;li&gt;
    &lt;button class="animation-button"&gt;Start animation&lt;/button&gt;
  &lt;/li&gt;
  &lt;li&gt;
    &lt;label for="easing-select"&gt;Choose an easing function:&lt;/label&gt;
    &lt;select id="easing-select"&gt;
      &lt;option selected&gt;linear&lt;/option&gt;
      &lt;option&gt;ease&lt;/option&gt;
      &lt;option&gt;ease-in&lt;/option&gt;
      &lt;option&gt;ease-in-out&lt;/option&gt;
      &lt;option&gt;ease-out&lt;/option&gt;
      &lt;option&gt;cubic-bezier(0.1, -0.6, 0.2, 0)&lt;/option&gt;
      &lt;option&gt;cubic-bezier(0, 1.1, 0.8, 4)&lt;/option&gt;
      &lt;option&gt;steps(5, end)&lt;/option&gt;
      &lt;option&gt;steps(3, start)&lt;/option&gt;
      &lt;option&gt;steps(4)&lt;/option&gt;
    &lt;/select&gt;
  &lt;/li&gt;
&lt;/ul&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">body &gt; div {
  position: relative;
  height: 100px;
}

div &gt; div {
  position: absolute;
  width: 50px;
  height: 50px;
  background-color: blue;
  background-image: radial-gradient(circle at 10px 10px, rgba(25,255,255,0.8),rgba(25,255,255,0.4));
  border-radius: 50%;
  top: 25px;
  animation: 1.5s infinite alternate;
}

@keyframes move-right {
  from {
    left: 10%;
  }

  to {
    left: 90%;
  }
}

li {
  display: flex;
  align-items: center;
  justify-content: center;
  margin-bottom: 20px;
}</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js notranslate">const selectElem = document.querySelector('select');
const startBtn = document.querySelector('button');
const divElem = document.querySelector('div &gt; div');

startBtn.addEventListener('click', () =&gt; {
  if(startBtn.textContent === 'Start animation') {
    divElem.style.animationName = 'move-right';
    startBtn.textContent = 'Stop animation';
    divElem.style.animationTimingFunction = selectElem.value;
  } else {
    divElem.style.animationName = 'unset';
    startBtn.textContent = 'Start animation';
  }
});

selectElem.addEventListener('change', () =&gt; {
  divElem.style.animationTimingFunction = selectElem.value;
});</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('Easing_function_comparison', '100%', 200)}}</p>

<h3 id="cubic-bezier_function_examples">cubic-bezier() function examples</h3>

<p>These cubic Bézier curves are valid for use in CSS:</p>

<pre class="brush: css notranslate">/* The canonical Bézier curve with four &lt;number&gt; in the [0,1] range. */
cubic-bezier(0.1, 0.7, 1.0, 0.1)

/* Using &lt;integer&gt; is valid as any &lt;integer&gt; is also a &lt;number&gt;. */
cubic-bezier(0, 0, 1, 1)

/* Negative values for ordinates are valid, leading to bouncing effects.*/
cubic-bezier(0.1, -0.6, 0.2, 0)

/* Values &gt; 1.0 for ordinates are also valid. */
cubic-bezier(0, 1.1, 0.8, 4)
</pre>

<p>These cubic Bézier curves definitions are invalid:</p>

<pre class="brush: css example-bad notranslate">/* Though the animated output type may be a color,
   Bézier curves work w/ numerical ratios.*/
cubic-bezier(0.1, red, 1.0, green)

/* Abscissas must be in the [0, 1] range or
   the curve is not a function of time. */
cubic-bezier(2.45, 0.6, 4, 0.1)

/* The two points must be defined, there is no default value. */
cubic-bezier(0.3, 2.1)

/* Abscissas must be in the [0, 1] range or
   the curve is not a function of time. */
cubic-bezier(-1.9, 0.3, -0.2, 2.1) </pre>

<h3 class="cleared" id="steps_function_examples">steps() function examples</h3>

<p>These easing functions are valid:</p>

<pre class="brush: css notranslate">/* There is 5 treads, the last one happens
   right before the end of the animation. */
steps(5, end)

/* A two-step staircase, the first one happening
   at the start of the animation. */
steps(2, start)

/* The second parameter is optional. */
steps(2)
</pre>

<p>These easing function are invalid:</p>

<pre class="brush: css example-bad notranslate">/* The first parameter must be an <a href="/en-US/docs/Web/CSS/integer">&lt;integer&gt;</a> and
   cannot be a real value, even if it is equal to one. */
steps(2.0, jump-end)

/* The amount of steps must be non-negative. */
steps(-3, start)

/* There must be at least one step.*/
steps(0, jump-none)</pre>

<h2 class="cleared" id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS Easing 1', '#typedef-easing-function', '&lt;easing-function&gt;')}}</td>
   <td>{{Spec2('CSS Easing 1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.types.easing-function", 2)}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Animations">CSS Animations</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Transitions">CSS Transitions</a></li>
 <li><a href="http://cubic-bezier.com/">cubic-bezier</a></li>
</ul>
